Package com.sas.metadata.remote

# Interface Report

All Superinterfaces:
  `Classifier`, `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Report extends Classifier
Represents the result of data being transformed into a report. The report has an association to a physical location, such as a SAS catalog entry or file.

Attributes of Report are:

- `ReportType`

Associations of Report are:

- `ReportLocation`
- `FileRefs`

## Usage

To create an instance of this Report, use the `factory` create methods.
Example: create a Report with name "Report_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Report myObject = (Report) factory.createComplexMetadataObject(objectStore, "Report_Object", MetadataObjects.REPORT, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_FILEREFS_NAME`
  Constant used for the name of the FileRefs association.
  `static final String`
  `ASSOCIATION_REPORTLOCATION_NAME`
  Constant used for the name of the ReportLocation association.
  `static final String`
  `ATTRIBUTE_REPORTTYPE_NAME`
  Constant used for the name of the ReportType attribute.

  ### Fields inherited from interface com.sas.metadata.remote.Classifier

  `ASSOCIATION_SOURCECLASSIFIERMAPS_NAME, ASSOCIATION_TARGETCLASSIFIERMAPS_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getFileRefs()`
  Gets the Association list of `FileRefs`
  `AssociationList`
  `getFileRefs(boolean fGoToServer)`
  Gets the Associationlist of `FileRefs`
  `ContentLocation`
  `getReportLocation()`
  Gets the `ContentLocation` for `ReportLocation`
  `AssociationList`
  `getReportLocations()`
  Gets the AssociationList of `ReportLocations`
  `AssociationList`
  `getReportLocations(boolean fGoToServer)`
  Gets the Associationlist of `ReportLocations`
  `String`
  `getReportType()`
  Gets the `String` value of `ReportType`
  `int`
  `getReportTypeMaxLength()`
  Gets the maximum length of `ReportType`
  `int`
  `getReportTypeState()`
  Gets the Metadata State of `ReportType`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `ReportLocation`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setFileRefs(AssociationList list)`
  Sets the `FileRefs` list to be `list`.
  `void`
  `setFileRefs(AssociationList inObjects, int state)`
  Sets the entire FileRefs list to match the passed in AssociationList, sets the state of the FileRefs
  `void`
  `setReportLocation(ContentLocation inObject)`
  Sets the `ReportLocations` list 0th element to be `inObject`.
  `void`
  `setReportLocations(AssociationList list)`
  Sets the `ReportLocations` list to be `list`.
  `void`
  `setReportLocations(AssociationList list, int state)`
  Sets the `ReportLocations` list to be `list`.
  `void`
  `setReportType(String inReportType)`
  Sets the `ReportType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setReportType(String inReportType, int state)`
  Sets the `ReportType` Metadata State.
  `void`
  `setReportTypeState(int state)`
  Sets the Metadata State of `ReportType`.

  ### Methods inherited from interface com.sas.metadata.remote.Classifier

  `getSourceClassifierMaps, getSourceClassifierMaps, getTargetClassifierMaps, getTargetClassifierMaps, setSourceClassifierMaps, setSourceClassifierMaps, setTargetClassifierMaps, setTargetClassifierMaps`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_REPORTTYPE_NAME

    static final String ATTRIBUTE_REPORTTYPE_NAME
    Constant used for the name of the ReportType attribute.

    ReportType: ReportType

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_REPORTLOCATION_NAME

    static final String ASSOCIATION_REPORTLOCATION_NAME
    Constant used for the name of the ReportLocation association.

    ReportLocation: The location of this report.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_FILEREFS_NAME

    static final String ASSOCIATION_FILEREFS_NAME
    Constant used for the name of the FileRefs association.

    FileRefs: The FileRefs that are used to generate this report.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `Classifier`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `ReportLocation`
    Specified by:
      `initializePredObjects` in interface `Classifier`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getReportType

    String getReportType() throws RemoteException
    Gets the `String` value of `ReportType`
    Returns:
      The `ReportType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getReportTypeState

    int getReportTypeState() throws RemoteException
    Gets the Metadata State of `ReportType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getReportTypeMaxLength

    int getReportTypeMaxLength() throws RemoteException
    Gets the maximum length of `ReportType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getReportLocations

    AssociationList getReportLocations() throws RemoteException, MdException
    Gets the AssociationList of `ReportLocations`
    Returns:
      Returns the AssociationList of `ReportLocations` which can be of type:
      ContentLocation
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
      Directory
      AnalyticContext
      Device
      Stream
      Memory
      Connection
      SASClientConnection
      OpenClientConnection
      TCPIPConnection
      COMConnection
      Email
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getReportLocation

    ContentLocation getReportLocation() throws RemoteException, MdException
    Gets the `ContentLocation` for `ReportLocation`
    Returns:
      The `ContentLocation` ( `null` if not set) of `ReportLocation`which can be of type:
      ContentLocation
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
      Directory
      AnalyticContext
      Device
      Stream
      Memory
      Connection
      SASClientConnection
      OpenClientConnection
      TCPIPConnection
      COMConnection
      Email
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getFileRefs

    AssociationList getFileRefs() throws RemoteException, MdException
    Gets the Association list of `FileRefs`
    Returns:
      The AssociationList of `FileRefs` which can be of type:
      SASFileRef
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getReportLocations

    AssociationList getReportLocations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ReportLocations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `ReportLocations` which can be of type:
      ContentLocation
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
      Directory
      AnalyticContext
      Device
      Stream
      Memory
      Connection
      SASClientConnection
      OpenClientConnection
      TCPIPConnection
      COMConnection
      Email
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getFileRefs

    AssociationList getFileRefs(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `FileRefs`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `FileRefs` which can be of type:
      SASFileRef
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setReportType

    void setReportType(String inReportType) throws RemoteException
    Sets the `ReportType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inReportType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReportType

    void setReportType(String inReportType, int state) throws RemoteException
    Sets the `ReportType` Metadata State.
    Parameters:
      `inReportType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReportTypeState

    void setReportTypeState(int state) throws RemoteException
    Sets the Metadata State of `ReportType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReportLocations

    void setReportLocations(AssociationList list) throws RemoteException
    Sets the `ReportLocations` list to be `list`. Object of which can be of type:
    ContentLocation
    Text
    TextStore
    SASCatalogEntry
    File
    ArchiveFile
    ArchiveEntry
    Document
    Directory
    AnalyticContext
    Device
    Stream
    Memory
    Connection
    SASClientConnection
    OpenClientConnection
    TCPIPConnection
    COMConnection
    Email
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReportLocations

    void setReportLocations(AssociationList list, int state) throws RemoteException
    Sets the `ReportLocations` list to be `list`. Object of which can be of type:
    ContentLocation
    Text
    TextStore
    SASCatalogEntry
    File
    ArchiveFile
    ArchiveEntry
    Document
    Directory
    AnalyticContext
    Device
    Stream
    Memory
    Connection
    SASClientConnection
    OpenClientConnection
    TCPIPConnection
    COMConnection
    Email
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReportLocation

    void setReportLocation(ContentLocation inObject) throws RemoteException
    Sets the `ReportLocations` list 0th element to be `inObject`.
    Parameters:
      `inObject` - ContentLocation
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFileRefs

    void setFileRefs(AssociationList list) throws RemoteException
    Sets the `FileRefs` list to be `list`. Objects of which can be of type:
    SASFileRef
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFileRefs

    void setFileRefs(AssociationList inObjects, int state) throws RemoteException
    Sets the entire FileRefs list to match the passed in AssociationList, sets the state of the FileRefs
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.